<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Variable Definitions</TITLE>
<link href="suif1_59.html" rel=Next>
<link href="suif1_57.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_57.html">previous</A>, <A HREF="suif1_59.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC58" HREF="suif1_toc.html#TOC58">Variable Definitions</A></H3>
<P>
<A NAME="IDX405"></A>

</P>
<P>
<A NAME="IDX406"></A>
<A NAME="IDX407"></A>
<A NAME="IDX408"></A>
Variable definitions are used to allocate storage for variables that are
not on the stack.  These variable definitions are implemented by the
<CODE>var_def</CODE> class, which is defined in the <TT>`vardef.h'</TT> and
<TT>`vardef.cc'</TT> files.  Each variable definition contains a field with
a pointer to the corresponding variable.  The <CODE>variable</CODE> and
<CODE>set_variable</CODE> methods access this field.

</P>
<P>
The effects of a variable definition depend on the kind of variable.
Without separate variable definitions, the symbols for global variables
are merely declarations of external symbols.  Adding a definition for a
global variable changes it from a declaration to an actual definition.
The local variables in a procedure or nested scope are allocated on the
stack by default.  Adding a definition for a local variable makes it
static.  Similarly, if you remove a definition of a local variable, it
reverts to being allocated on the stack.  Because of their special
status, register variables cannot have definitions.  Sub-variables are
also not allowed to have their own definitions.

</P>
<P>
The location of a <CODE>var_def</CODE> identifies the place where the variable
is defined.  For most variables, the <CODE>var_def</CODE> will be in the same
symbol table as the variable.  However, variables in the global symbol
table must be defined in exactly one of the source files.  Thus, the
<CODE>var_def</CODE> for a variable in the global symbol table must be in one
of the file symbol tables.

</P>
<P>
<A NAME="IDX409"></A>
<A NAME="IDX410"></A>
Besides identifying the location of the definition, a <CODE>var_def</CODE>
also specifies the alignment restriction for the variable's storage.
The <CODE>alignment</CODE> method retrieves the size of the alignment unit in
bits, and the <CODE>set_alignment</CODE> method sets the alignment unit size.
The alignment unit should be at least as big as the smallest addressable
unit for the target architecture.

</P>
<P>
The initial data for a static variable can be specified by attaching
annotations to the variable definition.  These annotations are optional.
If omitted, the initial data is assumed to be all zeros.  The initial
data annotations are described elsewhere in this manual.  See section <A HREF="suif1_75.html#SEC75">Initial Data Annotations</A>.

</P>
<P>
<A NAME="IDX411"></A>
Variable definitions are printed out as part of each symbol table.  The
<CODE>print</CODE> method is used for this.  You may also use this method for
debugging.  The optional <CODE>depth</CODE> parameter specifies the
indentation level for the output.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_57.html">previous</A>, <A HREF="suif1_59.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
